// Chat4 Demo V1.0.5.1
// von Johannes Hogrefe
// (johannes_hogrefe@web.de)

#define USE_TI92PLUS // Kompilieren fr TI-92PLUS
#define USE_V200 // Kompilieren fr TI Voyage 200

#define MIN_AMS 205 // Programm bentigrt AMS-Version 2.05

#include <tigcclib.h>

// Haupt Funktion
void _main(void)
{
  // Speichern des Bildschirms
  LCD_BUFFER *lcd = HeapAllocPtr(sizeof(LCD_BUFFER));
  LCD_save(lcd);
  
  //Lscht den Bildschirm
  clrscr();

  SCR_RECT screen_area={{0,0,239,127}};
  
  DrawClipRect(MakeWinRect(0,0,239,121),&screen_area, A_NORMAL);
  DrawLine(0,10,239,10,A_NORMAL);
  FontSetSys(F_4x6);  // Schriftgre KLEIN
  printf_xy(2,3,"Chat4 Demo von Johannes Hogrefe");
  DrawLine(0,65,239,65,A_NORMAL);
  
  // Definieren der Variablen
  int num = 0;
  int k = 0;
  int scroll = 0;
  int scroll2 = 0;
  char sent;
  char received;
  int x = 2, x2 = 2;
  int y = 67, y2 = 12;
  
  OSLinkOpen();  // ffnet den Link
  FontSetSys(F_6x8);  // Schriftgre MITTEL
  
  while (k != 264) 
  { 
    num = OSReadLinkBlock(&received, 1);  // Empfangen
      	
	  if (kbhit ())
    {
      k = ngetchx ();
      sent = k;
      OSWriteLinkBlock(&sent, 1);  // Senden
      if (k != 13)
      {
        printf_xy(x, y,"%c",k);
        x += 6;
      }
       
      if (x == 236 || k == 13)
      {
       	x = 2;
       	if (scroll != 1)
        {
        	y += 10;
        }
        else
        {
        	ScrRectScroll(&(SCR_RECT){{1, 67, 238, 117}},ScrRect,10,A_REVERSE);  // Scrollen	
        }
      }
      if (y == 107 && scroll != 1)
      {
        x = 2;
        scroll = 1;
      }
    }
     	
  	if (num != 0)
  	{
  		num = 0;
  		if (received != 13)
  		{
  		  printf_xy(x2, y2,"%c",received);
  		  x2 += 6;
  		}
  		
  		if (x2 == 236 || received == 13)
      {
       	x2 = 2;
       	if (scroll2 != 1)
        {
        	y2 += 10;
        }
        else
        {
        	ScrRectScroll(&(SCR_RECT){{1, 12, 238, 62}},ScrRect,10,A_REVERSE);  // Scrollen		
        }
      }
      if (y2 == 52 && scroll2 != 1)
      {
        x2 = 2;
        scroll2 = 1;
      }
  	}
	}
	OSLinkClose();  // Schliet den Link
	
	HeapFreePtr(lcd);
	LCD_restore(lcd);  // Bildschirm wiederherstellen
  ST_helpMsg("Chat4 Demo von Johannes Hogrefe");
}
